package com.tarak.api.netHandler;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.net.Socket;
import java.net.URL;
import java.net.URLEncoder;
import java.security.PublicKey;
import java.util.Random;
import javax.crypto.SecretKey;

import com.tarak.api.base.BotProject;
import com.tarak.api.base.CryptManager;
import com.tarak.api.base.GameThread;
import com.tarak.api.base.INetworkManager;
import com.tarak.api.base.AccountManager;
import com.tarak.api.packets.Packet;
import com.tarak.api.packets.Packet0KeepAlive;
import com.tarak.api.packets.Packet100OpenWindow;
import com.tarak.api.packets.Packet101CloseWindow;
import com.tarak.api.packets.Packet103SetSlot;
import com.tarak.api.packets.Packet104WindowItems;
import com.tarak.api.packets.Packet105UpdateProgressbar;
import com.tarak.api.packets.Packet106Transaction;
import com.tarak.api.packets.Packet10Flying;
import com.tarak.api.packets.Packet130UpdateSign;
import com.tarak.api.packets.Packet131MapData;
import com.tarak.api.packets.Packet132TileEntityData;
import com.tarak.api.packets.Packet16BlockItemSwitch;
import com.tarak.api.packets.Packet17Sleep;
import com.tarak.api.packets.Packet18Animation;
import com.tarak.api.packets.Packet1Login;
import com.tarak.api.packets.Packet200Statistic;
import com.tarak.api.packets.Packet201PlayerInfo;
import com.tarak.api.packets.Packet202PlayerAbilities;
import com.tarak.api.packets.Packet203AutoComplete;
import com.tarak.api.packets.Packet205ClientCommand;
import com.tarak.api.packets.Packet206SetObjective;
import com.tarak.api.packets.Packet207SetScore;
import com.tarak.api.packets.Packet208SetDisplayObjective;
import com.tarak.api.packets.Packet209SetPlayerTeam;
import com.tarak.api.packets.Packet20NamedEntitySpawn;
import com.tarak.api.packets.Packet22Collect;
import com.tarak.api.packets.Packet23VehicleSpawn;
import com.tarak.api.packets.Packet24MobSpawn;
import com.tarak.api.packets.Packet250CustomPayload;
import com.tarak.api.packets.Packet252SharedKey;
import com.tarak.api.packets.Packet253ServerAuthData;
import com.tarak.api.packets.Packet255KickDisconnect;
import com.tarak.api.packets.Packet25EntityPainting;
import com.tarak.api.packets.Packet26EntityExpOrb;
import com.tarak.api.packets.Packet28EntityVelocity;
import com.tarak.api.packets.Packet29DestroyEntity;
import com.tarak.api.packets.Packet30Entity;
import com.tarak.api.packets.Packet34EntityTeleport;
import com.tarak.api.packets.Packet35EntityHeadRotation;
import com.tarak.api.packets.Packet38EntityStatus;
import com.tarak.api.packets.Packet39AttachEntity;
import com.tarak.api.packets.Packet3Chat;
import com.tarak.api.packets.Packet40EntityMetadata;
import com.tarak.api.packets.Packet41EntityEffect;
import com.tarak.api.packets.Packet42RemoveEntityEffect;
import com.tarak.api.packets.Packet43Experience;
import com.tarak.api.packets.Packet4UpdateTime;
import com.tarak.api.packets.Packet51MapChunk;
import com.tarak.api.packets.Packet52MultiBlockChange;
import com.tarak.api.packets.Packet53BlockChange;
import com.tarak.api.packets.Packet54PlayNoteBlock;
import com.tarak.api.packets.Packet55BlockDestroy;
import com.tarak.api.packets.Packet56MapChunks;
import com.tarak.api.packets.Packet5PlayerInventory;
import com.tarak.api.packets.Packet60Explosion;
import com.tarak.api.packets.Packet61DoorChange;
import com.tarak.api.packets.Packet62LevelSound;
import com.tarak.api.packets.Packet63WorldParticles;
import com.tarak.api.packets.Packet6SpawnPosition;
import com.tarak.api.packets.Packet70GameEvent;
import com.tarak.api.packets.Packet71Weather;
import com.tarak.api.packets.Packet8UpdateHealth;
import com.tarak.api.packets.Packet9Respawn;


public class NetClientHandler extends NetHandler
{
    /** True if kicked or disconnected from the server. */
    public boolean disconnected = false;

    /** Reference to the NetworkManager object. */
    private INetworkManager netManager;
    public String field_72560_a;
    
    AccountManager api;
    
    GameThread gm;




    /**
     * An ArrayList of GuiPlayerInfo (includes all the players' GuiPlayerInfo on the current server)
     */
    public int currentServerMaxPlayers = 20;

    /** RNG. */
    Random rand = new Random();

    public NetClientHandler( String par2Str, int par3, AccountManager api) throws IOException
    {
    	this.api = api;
        Socket var4 = new Socket(par2Str, par3);
    	TcpConnection c = new TcpConnection(api.logger, var4, "Client", this, api);
    	this.gm = new GameThread(c, api);
        this.netManager = c;
    }
    
    public void setMessage(String s)
    {
    	this.sendPacket(new Packet3Chat(s));
    }

    /**
     * sets netManager and worldClient to null
     */
    public void cleanup()
    {
        if (this.netManager != null)
        {
            this.netManager.wakeThreads();
        }

        this.netManager = null;
        //this.worldClient = null;
    }

    /**
     * Processes the packets that have been read since the last call to this function.
     */
    public void processReadPackets()
    {
        if (!this.disconnected && this.netManager != null)
        {
            this.netManager.processReadPackets();
        }

        if (this.netManager != null)
        {
            this.netManager.wakeThreads();
        }
    }

    public void handleServerAuthData(Packet253ServerAuthData par1Packet253ServerAuthData)
    {
    	System.out.println("auth");
        String var2 = par1Packet253ServerAuthData.getServerId().trim();
        PublicKey var3 = par1Packet253ServerAuthData.getPublicKey();
        SecretKey var4 = CryptManager.createNewSharedKey();

        if (!"-".equals(var2))
        {
            String var5 = (new BigInteger(CryptManager.getServerIdHash(var2, var3, var4))).toString(16);
            String var6 = this.sendSessionRequest(this.api.session.username, this.api.session.sessionId, var5);

            if (!"ok".equalsIgnoreCase(var6))
            {
                this.netManager.networkShutdown("disconnect.loginFailedInfo", new Object[] {var6});
                return;
            }
        }

        this.sendPacket(new Packet252SharedKey(var4, var3, par1Packet253ServerAuthData.getVerifyToken()));
    }

    /**
     * Send request to http://session.minecraft.net with user's sessionId and serverId hash
     */
    private String sendSessionRequest(String par1Str, String par2Str, String par3Str)
    {
        try
        {
            URL var4 = new URL("http://session.minecraft.net/game/joinserver.jsp?user=" + urlEncode(par1Str) + "&sessionId=" + urlEncode(par2Str) + "&serverId=" + urlEncode(par3Str));
            BufferedReader var5 = new BufferedReader(new InputStreamReader(var4.openStream()));
            String var6 = var5.readLine();
            var5.close();
            return var6;
        }
        catch (IOException var7)
        {
            return var7.toString();
        }
    }

    /**
     * Encode the given string for insertion into a URL
     */
    private static String urlEncode(String par0Str) throws IOException
    {
        return URLEncoder.encode(par0Str, "UTF-8");
    }

    public void handleSharedKey(Packet252SharedKey par1Packet252SharedKey)
    {
        this.sendPacket(new Packet205ClientCommand(0));
    }

    public void handleLogin(Packet1Login par1Packet1Login)
    {
    	api.setStream(this);

    }

    public void handleVehicleSpawn(Packet23VehicleSpawn par1Packet23VehicleSpawn)
    {
    }

    /**
     * Handle a entity experience orb packet.
     */
    public void handleEntityExpOrb(Packet26EntityExpOrb par1Packet26EntityExpOrb)
    {

    }

    /**
     * Handles weather packet
     */
    public void handleWeather(Packet71Weather par1Packet71Weather)
    {

    }

    /**
     * Packet handler
     */
    public void handleEntityPainting(Packet25EntityPainting par1Packet25EntityPainting)
    {
    }

    /**
     * Packet handler
     */
    public void handleEntityVelocity(Packet28EntityVelocity par1Packet28EntityVelocity)
    {

    }

    /**
     * Packet handler
     */
    public void handleEntityMetadata(Packet40EntityMetadata par1Packet40EntityMetadata)
    {}

    public void handleNamedEntitySpawn(Packet20NamedEntitySpawn par1Packet20NamedEntitySpawn)
    {}

    public void handleEntityTeleport(Packet34EntityTeleport par1Packet34EntityTeleport)
    {}

    public void handleBlockItemSwitch(Packet16BlockItemSwitch par1Packet16BlockItemSwitch)
    {}

    public void handleEntity(Packet30Entity par1Packet30Entity)
    {}

    public void handleEntityHeadRotation(Packet35EntityHeadRotation par1Packet35EntityHeadRotation)
    {
//        Entity var2 = this.getEntityByID(par1Packet35EntityHeadRotation.entityId);
//
//        if (var2 != null)
//        {
//            float var3 = (float)(par1Packet35EntityHeadRotation.headRotationYaw * 360) / 256.0F;
//            var2.setRotationYawHead(var3);
//        }
    }

    public void handleDestroyEntity(Packet29DestroyEntity par1Packet29DestroyEntity)
    {
//        for (int var2 = 0; var2 < par1Packet29DestroyEntity.entityId.length; ++var2)
//        {
//            this.worldClient.removeEntityFromWorld(par1Packet29DestroyEntity.entityId[var2]);
//        }
    }

    public void handleFlying(Packet10Flying par1Packet10Flying)
    {

        
        

    }

    public void handleMultiBlockChange(Packet52MultiBlockChange par1Packet52MultiBlockChange)
    {

    }

    /**
     * Handle Packet51MapChunk (full chunk update of blocks, metadata, light levels, and optionally biome data)
     */
    public void handleMapChunk(Packet51MapChunk par1Packet51MapChunk)
    {

    }

    public void handleBlockChange(Packet53BlockChange par1Packet53BlockChange)
    {
    }

    public void handleKickDisconnect(Packet255KickDisconnect par1Packet255KickDisconnect)
    {
    	for(BotProject bot : api.getProjects())
    	{

    		bot.onKick(api,par1Packet255KickDisconnect.reason);
    	}
    }

    public void handleErrorMessage(String par1Str, Object[] par2ArrayOfObj)
    {

    }

    public void quitWithPacket(Packet par1Packet)
    {
        if (!this.disconnected)
        {
            this.netManager.addToSendQueue(par1Packet);
            this.netManager.serverShutdown();
        }
        
    }

    /**
     * Adds the packet to the send queue
     */
    public void sendPacket(Packet par1Packet)
    {
        if (!this.disconnected)
        {
            this.netManager.addToSendQueue(par1Packet);
        }
    }

    public void handleCollect(Packet22Collect par1Packet22Collect)
    {

    }

    public void handleChat(Packet3Chat par1Packet3Chat)
    {
    	for(BotProject bot : api.getProjects())
    	{
    		bot.onChatReceive(api, par1Packet3Chat.message);
    	}
    }

    public void handleAnimation(Packet18Animation par1Packet18Animation)
    {
//        Entity var2 = this.getEntityByID(par1Packet18Animation.entityId);
//
//        if (var2 != null)
//        {
//            if (par1Packet18Animation.animate == 1)
//            {
//                EntityLiving var3 = (EntityLiving)var2;
//                var3.swingItem();
//            }
//            else if (par1Packet18Animation.animate == 2)
//            {
//                var2.performHurtAnimation();
//            }
//            else if (par1Packet18Animation.animate == 3)
//            {
//                EntityPlayer var4 = (EntityPlayer)var2;
//                var4.wakeUpPlayer(false, false, false);
//            }
//            else if (par1Packet18Animation.animate != 4)
//            {
//                if (par1Packet18Animation.animate == 6)
//                {
//                    this.mc.effectRenderer.addEffect(new EntityCrit2FX(this.mc.theWorld, var2));
//                }
//                else if (par1Packet18Animation.animate == 7)
//                {
//                    EntityCrit2FX var5 = new EntityCrit2FX(this.mc.theWorld, var2, "magicCrit");
//                    this.mc.effectRenderer.addEffect(var5);
//                }
//                else if (par1Packet18Animation.animate == 5 && var2 instanceof EntityOtherPlayerMP)
//                {
//                    ;
//                }
//            }
//        }
    }

    public void handleSleep(Packet17Sleep par1Packet17Sleep)
    {
//        Entity var2 = this.getEntityByID(par1Packet17Sleep.entityID);
//
//        if (var2 != null)
//        {
//            if (par1Packet17Sleep.field_73622_e == 0)
//            {
//                EntityPlayer var3 = (EntityPlayer)var2;
//                var3.sleepInBedAt(par1Packet17Sleep.bedX, par1Packet17Sleep.bedY, par1Packet17Sleep.bedZ);
//            }
//        }
    }

    /**
     * Disconnects the network connection.
     */
    public void disconnect()
    {
        this.disconnected = true;
        this.netManager.wakeThreads();
        this.netManager.networkShutdown("disconnect.closed", new Object[0]);
    }

    public void handleMobSpawn(Packet24MobSpawn par1Packet24MobSpawn)
    {

    }

    public void handleUpdateTime(Packet4UpdateTime par1Packet4UpdateTime)
    {
    }

    public void handleSpawnPosition(Packet6SpawnPosition par1Packet6SpawnPosition)
    {
    }

    /**
     * Packet handler
     */
    public void handleAttachEntity(Packet39AttachEntity par1Packet39AttachEntity)
    {

    }

    /**
     * Packet handler
     */
    public void handleEntityStatus(Packet38EntityStatus par1Packet38EntityStatus)
    {

    }

//    private Entity getEntityByID(int par1)
//    {
//        return (Entity)(par1 == this.mc.thePlayer.entityId ? this.mc.thePlayer : this.worldClient.getEntityByID(par1));
//    }

    /**
     * Recieves player health from the server and then proceeds to set it locally on the client.
     */
    public void handleUpdateHealth(Packet8UpdateHealth par1Packet8UpdateHealth)
    {

    }

    /**
     * Handle an experience packet.
     */
    public void handleExperience(Packet43Experience par1Packet43Experience)
    {
        //this.mc.thePlayer.setXPStats(par1Packet43Experience.experience, par1Packet43Experience.experienceTotal, par1Packet43Experience.experienceLevel);
    }

    /**
     * respawns the player
     */
    public void handleRespawn(Packet9Respawn par1Packet9Respawn)
    {

    }

    public void handleExplosion(Packet60Explosion par1Packet60Explosion)
    {
    }

    public void handleOpenWindow(Packet100OpenWindow par1Packet100OpenWindow)
    {
    }

    public void handleSetSlot(Packet103SetSlot par1Packet103SetSlot)
    {

    }

    public void handleTransaction(Packet106Transaction par1Packet106Transaction)
    {

    }

    public void handleWindowItems(Packet104WindowItems par1Packet104WindowItems)
    {

    }

    /**
     * Updates Client side signs
     */
    public void handleUpdateSign(Packet130UpdateSign par1Packet130UpdateSign)
    {

    }

    public void handleTileEntityData(Packet132TileEntityData par1Packet132TileEntityData)
    {

    }

    public void handleUpdateProgressbar(Packet105UpdateProgressbar par1Packet105UpdateProgressbar)
    {

    }

    public void handlePlayerInventory(Packet5PlayerInventory par1Packet5PlayerInventory)
    {

    }

    public void handleCloseWindow(Packet101CloseWindow par1Packet101CloseWindow)
    {
        //this.mc.thePlayer.func_92015_f();
    }

    public void handleBlockEvent(Packet54PlayNoteBlock par1Packet54PlayNoteBlock)
    {
        //this.mc.theWorld.addBlockEvent(par1Packet54PlayNoteBlock.xLocation, par1Packet54PlayNoteBlock.yLocation, par1Packet54PlayNoteBlock.zLocation, par1Packet54PlayNoteBlock.blockId, par1Packet54PlayNoteBlock.instrumentType, par1Packet54PlayNoteBlock.pitch);
    }

    public void handleBlockDestroy(Packet55BlockDestroy par1Packet55BlockDestroy)
    {
    	
        //his.mc.theWorld.destroyBlockInWorldPartially(par1Packet55BlockDestroy.getEntityId(), par1Packet55BlockDestroy.getPosX(), par1Packet55BlockDestroy.getPosY(), par1Packet55BlockDestroy.getPosZ(), par1Packet55BlockDestroy.getDestroyedStage());
    }

    public void handleMapChunks(Packet56MapChunks par1Packet56MapChunks)
    {

    }

    /**
     * If this returns false, all packets will be queued for the main thread to handle, even if they would otherwise be
     * processed asynchronously. Used to avoid processing packets on the client before the world has been downloaded
     * (which happens on the main thread)
     */
    public boolean canProcessPacketsAsync()
    {
    	return true;
        //return this.mc != null && this.mc.theWorld != null && this.mc.thePlayer != null && this.worldClient != null;
    }

    public void handleGameEvent(Packet70GameEvent par1Packet70GameEvent)
    {

    }

    /**
     * Contains logic for handling packets containing arbitrary unique item data. Currently this is only for maps.
     */
    public void handleMapData(Packet131MapData par1Packet131MapData)
    {

    }

    public void handleDoorChange(Packet61DoorChange par1Packet61DoorChange)
    {

    }

    /**
     * Increment player statistics
     */
    public void handleStatistic(Packet200Statistic par1Packet200Statistic)
    {
    }

    /**
     * Handle an entity effect packet.
     */
    public void handleEntityEffect(Packet41EntityEffect par1Packet41EntityEffect)
    {

    }

    /**
     * Handle a remove entity effect packet.
     */
    public void handleRemoveEntityEffect(Packet42RemoveEntityEffect par1Packet42RemoveEntityEffect)
    {

    }

    /**
     * determine if it is a server handler
     */
    public boolean isServerHandler()
    {
        return false;
    }

    /**
     * Handle a player information packet.
     */
    public void handlePlayerInfo(Packet201PlayerInfo par1Packet201PlayerInfo)
    {
//        GuiPlayerInfo var2 = (GuiPlayerInfo)this.playerInfoMap.get(par1Packet201PlayerInfo.playerName);
//
//        if (var2 == null && par1Packet201PlayerInfo.isConnected)
//        {
//            var2 = new GuiPlayerInfo(par1Packet201PlayerInfo.playerName);
//            this.playerInfoMap.put(par1Packet201PlayerInfo.playerName, var2);
//            this.playerInfoList.add(var2);
//        }
//
//        if (var2 != null && !par1Packet201PlayerInfo.isConnected)
//        {
//            this.playerInfoMap.remove(par1Packet201PlayerInfo.playerName);
//            this.playerInfoList.remove(var2);
//        }
//
//        if (par1Packet201PlayerInfo.isConnected && var2 != null)
//        {
//            var2.responseTime = par1Packet201PlayerInfo.ping;
//        }
    }

    /**
     * Handle a keep alive packet.
     */
    public void handleKeepAlive(Packet0KeepAlive par1Packet0KeepAlive)
    {
        this.sendPacket(new Packet0KeepAlive(par1Packet0KeepAlive.randomId));
    }

    /**
     * Handle a player abilities packet.
     */
    public void handlePlayerAbilities(Packet202PlayerAbilities par1Packet202PlayerAbilities)
    {
//        EntityClientPlayerMP var2 = this.mc.thePlayer;
//        var2.capabilities.isFlying = par1Packet202PlayerAbilities.getFlying();
//        var2.capabilities.isCreativeMode = par1Packet202PlayerAbilities.isCreativeMode();
//        var2.capabilities.disableDamage = par1Packet202PlayerAbilities.getDisableDamage();
//        var2.capabilities.allowFlying = par1Packet202PlayerAbilities.getAllowFlying();
//        var2.capabilities.setFlySpeed(par1Packet202PlayerAbilities.getFlySpeed());
//        var2.capabilities.setPlayerWalkSpeed(par1Packet202PlayerAbilities.func_82558_j());
    }

    public void handleAutoComplete(Packet203AutoComplete par1Packet203AutoComplete)
    {

    }

    public void handleLevelSound(Packet62LevelSound par1Packet62LevelSound)
    {
    }

    public void handleCustomPayload(Packet250CustomPayload par1Packet250CustomPayload)
    {
    }

    public void func_96436_a(Packet206SetObjective par1Packet206SetObjective)
    {

    }

    public void func_96437_a(Packet207SetScore par1Packet207SetScore)
    {

    }

    public void func_96438_a(Packet208SetDisplayObjective par1Packet208SetDisplayObjective)
    {

    }

    public void func_96435_a(Packet209SetPlayerTeam par1Packet209SetPlayerTeam)
    {

    }

    public void func_98182_a(Packet63WorldParticles par1Packet63WorldParticles)
    {

    }

    /**
     * Return the NetworkManager instance used by this NetClientHandler
     */
    public INetworkManager getNetManager()
    {
        return this.netManager;
    }
}
