package com.tarak.api.netHandler;

import java.net.ConnectException;
import java.net.UnknownHostException;

import com.tarak.api.base.Connecter;
import com.tarak.api.base.AccountManager;
import com.tarak.api.packets.Packet2ClientProtocol;


public class ThreadConnectToServer extends Thread
{
    /** The IP address or domain used to connect. */
    final String ip;

    /** The port used to connect. */
    final int port;
    
    AccountManager api;

    /** A reference to the Connecter object. */
    final Connecter connectingGui;

    public ThreadConnectToServer(Connecter par1Connecter, String par2Str, int par3, AccountManager api)
    {
    	this.api = api;
        this.ip = par2Str;
        this.port = par3;
        connectingGui = par1Connecter;
    }

    public void run()
    {
        try
        {
            Connecter.setNetClientHandler(this.connectingGui, new NetClientHandler( this.ip, this.port, this.api));
            if (Connecter.isCancelled(this.connectingGui))
            {
                return;
            }
            Connecter.getNetClientHandler(this.connectingGui).sendPacket(new Packet2ClientProtocol(60, this.api.session.username, this.ip, this.port));
        }
        catch (UnknownHostException var2)
        {
            if (Connecter.isCancelled(this.connectingGui))
            {
                return;
            }

        }
        catch (ConnectException var3)
        {
            if (Connecter.isCancelled(this.connectingGui))
            {
                return;
            }

        }
        catch (Exception var4)
        {
            if (Connecter.isCancelled(this.connectingGui))
            {
                return;
            }

            var4.printStackTrace();
        }
    }
}
