package com.tarak.api.base;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;

import javax.net.ssl.HttpsURLConnection;
import com.tarak.api.netHandler.NetClientHandler;
import com.tarak.api.packets.ILogAgent;



public class AccountManager {
	
	
	public Session session;
	
	private ArrayList<BotProject> eventListener = new ArrayList<BotProject>();
	
	public ILogAgent logger = new ILogAgent(){

		@Override
		public void logInfo(String var1) {
			System.out.println("[INFO] "+var1);
		}

		@Override
		public void logWarning(String var1) {
			System.out.println("[WARNING] "+var1);
		}

		@Override
		public void func_98231_b(String var1, Object... var2) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void func_98235_b(String var1, Throwable var2) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void func_98232_c(String var1) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void func_98234_c(String var1, Throwable var2) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void func_98230_d(String var1) {
			// TODO Auto-generated method stub
			
		}
		
	};
	
	
	public AccountManager(BotProject project) {
		this.eventListener.add(project);
	}
	

	
	
	public ArrayList<BotProject> getProjects()
	{
		return this.eventListener;
	}


	
	
	/**
	 * This is Optional, it will allow you to login to servers with an alternate IP address.
	 * 
	 * @param Server Address
	 * @param Server Port
	 */
	public void setProxy(String address, int port)
	{
        System.setProperty("socksProxyHost", address);
        System.setProperty("socksProxyPort", ""+port);
	}
	
	/**
	 * Logs you into Minecraft, it will determine the Username you login the server with.
	 * You MUST set your proxy (If needed) before you login!
	 * @param Username
	 * @param Password
	 * @return Login successful
	 */
    public boolean login(String username, String password)
    {
    	if(username.length()>0)
        if (password.length() > 0)
        {
            String var2 = username;
            String var3 = password;

            try
            {
                String var4 = "user=" + URLEncoder.encode(var2, "UTF-8") + "&password=" + URLEncoder.encode(var3, "UTF-8") + "&version=" + 13;
                String var5 = executePost("https://login.minecraft.net", var4);

                if (var5 == null || !var5.contains(":"))
                {
                	this.session = new Session(var2, "");
                    return false;
                }

                String[] var6 = var5.split(":");
                this.session = new Session(var6[2].trim(), var6[3].trim());
                return true;
            }
            catch (Exception var7)
            {
                ;
            }
        }
        else
        {
            this.session = new Session(username, "");
        }
        return false;
    }
    

    @SuppressWarnings("null")
	private String executePost(String var0, String var1)
    {
        HttpsURLConnection var2 = null;
        URL var3;

        try
        {
            var3 = new URL(var0);
            var2 = (HttpsURLConnection)var3.openConnection();
            var2.setRequestMethod("POST");
            var2.setRequestProperty("Content-Type", "application/form-urlencoded");
            var2.setRequestProperty("Content-Length", Integer.toString(var1.getBytes().length));
            var2.setRequestProperty("Content-Launguage", "en-US");
            var2.setUseCaches(false);
            var2.setDoInput(true);
            var2.setDoOutput(true);
            var2.connect();
            DataOutputStream var4 = new DataOutputStream(var2.getOutputStream());
            var4.writeBytes(var1);
            var4.flush();
            var4.close();
            InputStream var5 = var2.getInputStream();
            BufferedReader var6 = new BufferedReader(new InputStreamReader(var5));
            StringBuffer var7 = new StringBuffer();
            String var8;

            while ((var8 = var6.readLine()) != null)
            {
                var7.append(var8);
                var7.append('\r');
            }

            var6.close();
            String var9 = var7.toString();
            String var11 = var9;
            return var11;
        }
        catch (Exception var15)
        {
            var15.printStackTrace();
            var3 = null;
        }
        finally
        {
            if (var2 != null)
            {
                var2.disconnect();
            }
        }

        return var3.toString();
    }
    
    /**
     * Will disconnect you from any server you are currently on.
     */
    public void disconnect(){
    	if(this.getStream()!=null)
    	this.getStream().disconnect();
    }
    
    
    /**
     * Will log you into the Minecraft server the address and port have specified.
     * If server isn't cracked, you must login first.
     * 
     * @param Server Address
     * @param Server Port
     */
    public void connectToServer(String address, int port)
    {
    	new Connecter(address, port, this);
    }
    
    /**
     * Will log you into the Minecraft server the address and port have specified.
     * If server isn't cracked, you must login first.
     * 
     * @param Server Address
     *
     */
    public void connectToServer(String address)
    {
    	new Connecter(address, 25565, this);
    }
   
    
    private NetClientHandler netHandler;
    
    
    /**
     * Gets the TCP connection to server, will return null if not connected to a server.
     * Primarily used to send packets.
     * @return
     */
    public NetClientHandler getStream() {
		return netHandler;
	}


	public void setStream(NetClientHandler netClientHandler) {
		this.netHandler = netClientHandler;
	}
    
}
